

Application create: #JRUtility with:
    (#( AbtBaseApp)
        collect: [:each | Smalltalk at: each ifAbsent: [
            Application errorPrerequisite: #JRUtility missing: each]])!

JRUtility becomeDefault!
Object subclass: #CaseStatement
    instanceVariableNames: 'cases defaultCase '
    classVariableNames: ''
    poolDictionaries: ''!

JRUtility becomeDefault!
Application subclass: #JRUtility
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!


JRUtility becomeDefault!

!CaseStatement class publicMethods !

addAll: associationsOrDictionary
	^self addAll: associationsOrDictionary default: [Transcript show: 'No Such Case']!

addAll: associationsOrDictionary default: default
	^self new addAll: associationsOrDictionary default: default!

new
	^super new initialize!

simpleDefaultCase
	^[Transcript show: 'No Such Case']! !

!CaseStatement publicMethods !

addAll: associationsOrDictionary
	self addAll: associationsOrDictionary default: self simpleDefaultCase!

addAll: associationsOrDictionary default: default
	|associations |
	
	associations := associationsOrDictionary isDictionary
		ifTrue: [associationsOrDictionary associations]
		ifFalse: [associationsOrDictionary].
	associations do: [:each | self addCase: each].
	defaultCase := default!

addCase: anAssociation
	"the key should be a symbol, while the value should be anything that responds to #value (presumably a block)"
	
		|key |
		
		key := anAssociation key isString
			ifTrue: [anAssociation key asSymbol]
			ifFalse: [anAssociation key].
			
		cases at: key put: anAssociation value!

caseAt: keyName
	"execute the corresponding value"
	
	| key val |
	
	key := keyName isString
		ifTrue: [keyName asSymbol]
		ifFalse: [keyName].
		
	val := self cases at: key ifAbsent: self defaultCase.
	^val value!

cases
	^cases!

cases: aValue
	cases := aValue!

defaultCase
	^defaultCase!

defaultCase: aValue
	defaultCase := aValue!

initialize
	cases := Dictionary new.
	defaultCase := self simpleDefaultCase!

removeCase: name
	
		|key |
		
		key := name isString
			ifTrue: [name asSymbol]
			ifFalse: [name].
			
		cases removeKey: key ifAbsent: [nil]!

simpleDefaultCase
	^self class simpleDefaultCase! !

CaseStatement initializeAfterLoad!
JRUtility initializeAfterLoad!

JRUtility loaded!